<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Generating plain text content of content elements for Direct Mails
 *
 * Normally the plain text output should appear with type=99
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

 
class user_plaintext {
	var $cObj;
	var $conf=array();
	var $charWidth=76;
	
	function main_plaintext($content,$conf)	{
		$this->conf = $conf;
		$this->siteUrl=$conf["siteUrl"];
		$lines = array();
		$CType= (string)$this->cObj->data["CType"];
		switch($CType)	{
			case "header":
				$lines[]=$this->getHeader();
				if ($this->cObj->data["subheader"])	{
					$lines[]=$this->breakContent(strip_tags($this->cObj->data["subheader"]));
				}
			break;
			case "text":
			case "textpic":
				$lines[]=$this->getHeader();
				if ($CType=="textpic" && !($this->cObj->data["imageorient"]&24))	{
					$lines[]=$this->getImages();
					$lines[]="";
				}
				$lines[]=$this->breakContent(strip_tags($this->parseBody($this->cObj->data["bodytext"])));
				if ($CType=="textpic" && ($this->cObj->data["imageorient"]&24))	{
					$lines[]="";
					$lines[]=$this->getImages();
				}
			break;
			case "image":
				$lines[]=$this->getHeader();
				$lines[]=$this->getImages();
			break;
			case "uploads":
				$lines[]=$this->getHeader();
				$lines[]=$this->renderUploads($this->cObj->data["media"]);
			break;
			case "menu":
				$lines[]=$this->getHeader();
				$lines[]=$this->getMenuSitemap();
			break;
			case "shortcut":
//				$lines[]=$this->getHeader();
				$lines[]=$this->getShortcut();
			break;
			case "bullets":
				$lines[]=$this->getHeader();
				$lines[]=$this->breakBulletlist(strip_tags($this->parseBody($this->cObj->data["bodytext"])));
			break;
			case "table":
				$lines[]=$this->getHeader();
				$lines[]=$this->breakTable(strip_tags($this->parseBody($this->cObj->data["bodytext"])));
			break;
			case "html":
				$lines[]=$this->getHTML();
			break;
			default:
				$defaultOutput = $this->getString($this->conf["defaultOutput"]);
				if ($defaultOutput)	{
					$lines[]=str_replace("###CType###",$CType,$defaultOutput);
				}
			break;
		}

		$lines[]="";	// First break.
//debug($lines)		;
		$content = implode(chr(10),$lines);
		
			// User processing:
		$content=$this->userProcess("userProc",$content);
		return $content;
	}
	function parseBody($str)	{
			// First, regular parsing:
		$str = eregi_replace("<br[ /]*>"," ",$str);
		$str = $this->cObj->stdWrap($str,$this->conf["bodytext."]["stdWrap."]);
			// Then all a-tags:
		$aConf = array();
		$aConf["parseFunc."]["tags."]["a"]="USER";
		$aConf["parseFunc."]["tags."]["a."]["userFunc"]="user_plaintext->atag_to_http";
		$aConf["parseFunc."]["tags."]["a."]["siteUrl"] = $this->siteUrl;

		$str = $this->cObj->stdWrap($str,$aConf);
		$str = str_replace("&nbsp;"," ",t3lib_div::htmlspecialchars_decode($str));
		return $str;
	}
	function atag_to_http($content,$conf)	{
		$this->conf = $conf;
		$this->siteUrl=$conf["siteUrl"];
		$theLink  = trim($this->cObj->parameters["href"]);
		if (strtolower(substr($theLink,0,7))=="mailto:")	{
			$theLink=substr($theLink,7);
		} elseif (substr($theLink,0,4)!="http")	{
			$theLink=$this->siteUrl.$theLink;
		}
		return $this->cObj->getCurrentVal()." (Link: ".$theLink.")";
	}
	function getMenuSitemap()	{
		$str = $this->cObj->cObjGetSingle($this->conf["menu"],$this->conf["menu."]);
//		$str = $this->getHTML($str);
		$str = $this->breakBulletlist(trim(strip_tags(eregi_replace("<BR>",chr(10),$this->parseBody($str)))));
		return $str;
	}
	function getShortcut()	{
		$str = $this->cObj->cObjGetSingle($this->conf["shortcut"],$this->conf["shortcut."]);
		return $str;
	}
	function getHTML($str=array())	{
		return $this->breakContent(strip_tags(eregi_replace("<BR>",chr(10),$this->parseBody(is_string($str)?$str:$this->cObj->data["bodytext"]))));
	}
	function getHeader()	{
		// links...
		return $this->renderHeader($this->cObj->data["header"],$this->cObj->data["header_layout"]);
	}
	function getImages()	{
		$images = $this->renderImages($this->cObj->data["image"],!$this->cObj->data["image_zoom"]?$this->cObj->data["image_link"]:"",$this->cObj->data["imagecaption"]);
		return $images;
	}
	function renderUploads($str,$upload_path="uploads/media/")	{
		$files = explode(",",$str);
		reset($files);
		$lines=array();
		if ($this->conf["uploads."]["header"])	{$lines[]=$this->getString($this->conf["uploads."]["header"]);}
		while(list($k,$file)=each($files))	{
			$lines[]=$this->siteUrl.$upload_path.$file;
		}
		return implode(chr(10),$lines);
	}
	function renderHeader($str,$type=0)	{
		if ($str)	{
			$hConf = $this->conf["header."];
			$defaultType = t3lib_div::intInRange($hConf["defaultType"],1,5);
			$type=t3lib_div::intInRange($type,0,6);
			if (!$type)	$type=$defaultType;
			if ($type!=6)	{	// not hidden
				$tConf = $hConf[$type."."];
		
				$lines=array();
		
				$blanks = t3lib_div::intInRange($tConf["preBlanks"],0,1000);
				if ($blanks)	{
					$lines[]=str_pad("", $blanks-1, chr(10)); 
				}
				
				$lines=$this->pad($lines,$tConf["preLineChar"],$tConf["preLineLen"]);
	
				$blanks = t3lib_div::intInRange($tConf["preLineBlanks"],0,1000);
				if ($blanks)	{$lines[]=str_pad("", $blanks-1, chr(10));}
	
				if ($this->cObj->data["date"])		{$lines[] = $this->getString($hConf["datePrefix"]).date($hConf["date"]?$hConf["date"]:"d-m-Y",$this->cObj->data["date"]);}
				$prefix="";
				$str=$this->getString($tConf["prefix"]).$str;
				if ($tConf["autonumber"])	$str=$this->cObj->parentRecordNumber.$str;
				if ($this->cObj->data["header_position"]=="right")	{$prefix=str_pad(" ",($this->charWidth-strlen($str)));}
				if ($this->cObj->data["header_position"]=="center")	{$prefix=str_pad(" ",floor(($this->charWidth-strlen($str))/2));}
				$lines[]=$this->cObj->stdWrap($prefix.$str,$tConf["stdWrap."]);
				if ($this->cObj->data["header_link"])		{$lines[] = $this->getString($hConf["linkPrefix"]).$this->getLink($this->cObj->data["header_link"]);}
		
				$blanks = t3lib_div::intInRange($tConf["postLineBlanks"],0,1000);
				if ($blanks)	{$lines[]=str_pad("", $blanks-1, chr(10));}
	
				$lines=$this->pad($lines,$tConf["postLineChar"],$tConf["postLineLen"]);
		
				$blanks = t3lib_div::intInRange($tConf["postBlanks"],0,1000);
				if ($blanks)	{$lines[]=str_pad("", $blanks-1, chr(10));}
	//			debug($lines);
				return implode(chr(10),$lines);
			}
		}		
	}
	function pad($lines,$preLineChar,$len)	{
		$strPad = t3lib_div::intInRange($len,0,1000);
		$strPadChar = $preLineChar?$preLineChar:"-";
		if ($strPad)	{
			$lines[]=str_pad("", $strPad, $strPadChar); 
		}
		return $lines;
	}
	function breakContent($str)	{
		$cParts = explode(chr(10),$str);
		reset($cParts);
		$lines=array();
		while(list(,$substrs)=each($cParts))	{
			$lines[]=$this->breakLines($substrs);
		}
		return implode(chr(10),$lines);
	}
	function breakBulletlist($str)	{
		$type = $this->cObj->data["layout"];
		$type=t3lib_div::intInRange($type,0,3);

		$tConf = $this->conf["bulletlist."][$type."."];
		
		$cParts = explode(chr(10),$str);
		reset($cParts);
		$lines=array();
		$c=0;
		while(list(,$substrs)=each($cParts))	{
			$c++;
			$bullet = $tConf["bullet"] ? $this->getString($tConf["bullet"]) : " - ";
			$bLen=strlen($bullet);
			$bullet = substr(str_replace("#",$c,$bullet),0,$bLen);
			$secondRow = substr($tConf["secondRow"]?$this->getString($tConf["secondRow"]):str_pad("",strlen($bullet)," "),0,$bLen);
			
			$lines[]=$bullet.$this->breakLines($substrs,"\n".$secondRow,$this->charWidth-$bLen);

			$blanks = t3lib_div::intInRange($tConf["blanks"],0,1000);
			if ($blanks)	{$lines[]=str_pad("", $blanks-1, chr(10));}
		}
		return implode(chr(10),$lines);
	}
	function breakTable($str)	{
		$cParts = explode(chr(10),$str);
		reset($cParts);
		$lines=array();
		$cols = intval($this->conf["cols"]) ? intval($this->conf["cols"]) : 0 ;
		$c=0;
		while(list(,$substrs)=each($cParts))	{
			$c++;
			if (trim($substrs))	{
				$lineParts=explode("|",$substrs);
				if (!$cols)	$cols=count($lineParts);
				
				for ($a=0;$a<$cols;$a++)	{
					$jdu = explode(chr(10),$this->breakLines($lineParts[$a],"\n",ceil($this->charWidth/$cols)));				
					$lines[$c][$a]=$jdu;
				}
			}
//			$lines[]=$this->breakLines($substrs);
		}
		$messure = $this->traverseTable($lines);
		
		
		$divChar="-";
		$joinChar="+";
		$colChar="|";
		
		// Make table:
		$outLines = array();
		$outLines[]=$this->addDiv($messure,"",$divChar,$joinChar,$cols);

		reset($lines);
		while(list($k,$v)=each($lines))	{
			$top = intval($messure[1][$k]);
			for ($aa=0;$aa<$top;$aa++)	{
				$tempArr=array();
				for ($bb=0;$bb<$cols;$bb++)	{
					$tempArr[$bb]=str_pad($v[$bb][$aa],$messure[0][$bb]," ");
				}
				$outLines[]=$colChar.implode($colChar,$tempArr).$colChar;
			}
			$outLines[]=$this->addDiv($messure,"",$divChar,$joinChar,$cols);
		}
//debug($lines);
//debug($messure);
		return implode(chr(10),$outLines);
	}
	function addDiv($messure,$content,$divChar,$joinChar,$cols)	{
		$tempArr=array();
		for ($a=0;$a<$cols;$a++)	{
			$tempArr[$a]=str_pad($content,$messure[0][$a],$divChar);
		}
		return $joinChar.implode($joinChar,$tempArr).$joinChar;
	}
	function traverseTable($tableLines)	{
		$maxLen=array();
		$maxLines=array();
		reset($tableLines);
		while(list($k,$v)=each($tableLines))	{
			reset($v);
			while(list($kk,$vv)=each($v))	{
				reset($vv);
				while(list($lk,$lv)=each($vv))	{
					if (strlen($lv)>intval($maxLen[$kk]))	$maxLen[$kk]=strlen($lv);
				}
				if (count($vv)>intval($maxLines[$k]))	$maxLines[$k]=count($vv);
			}
		}
		return array($maxLen,$maxLines); 
	}
	function renderImages($str,$links,$caption,$upload_path="uploads/pics/")	{
		$images = explode(",",$str);
		$linksArr = explode(",",$links);
		reset($images);
		$lines=array();
		if ($this->conf["images."]["header"])	{$lines[]=$this->getString($this->conf["images."]["header"]);}
		while(list($k,$file)=each($images))	{
			$lines[]=$this->siteUrl.$upload_path.$file;
			if ($links && count($linksArr)>1)	{
				if (isset($linksArr[$k]))	{
					$ll=$linksArr[$k];
				} else {
					$ll=$linksArr[0];
				}
				
				$theLink = $this->getLink($ll);
				if ($theLink)	{$lines[]=$this->getString($this->conf["images."]["linkPrefix"]).$theLink;}
			}
		}
		if ($links && count($linksArr)==1)	{
			$theLink = $this->getLink($links);
			if ($theLink)	{$lines[]=$this->getString($this->conf["images."]["linkPrefix"]).$theLink;}
		}
		if ($caption)	{
			$lines[]="";
			$cHeader = trim($this->getString($this->conf["images."]["captionHeader"]));
			if ($cHeader)		$lines[]=$cHeader;
			$lines[]=$this->breakContent($caption);
		}
		
//		debug();
		return implode(chr(10),$lines);
	}
	function getLink($ll)	{
		$theLink=$this->cObj->getTypoLink_URL($ll);
		if (substr($theLink,0,4)!="http")	{
			$theLink=$this->siteUrl.$theLink;
		}
		return $theLink;		
	}
	function breakLines($str,$implChar="\n",$charWidth=0)	{
		return t3lib_div::breakLinesForEmail($str,$implChar,$charWidth?$charWidth:$this->charWidth);
	}
	function getString($str)	{
		$parts = explode("|",$str);
		return strcmp($parts[1],"")?$parts[1]:$parts[0];
	}
	function typolist($content,$conf)	{	
		$this->conf = $this->cObj->mergeTSRef($conf,"bulletlist");
		$this->siteUrl=$conf["siteUrl"];
		$str = trim($this->cObj->getCurrentVal());
		$this->cObj->data["layout"] = $this->cObj->parameters["type"];
		return $this->breakBulletlist($str);
	}
	function typohead($content,$conf)	{	
		$this->conf = $this->cObj->mergeTSRef($conf,"header");
//		debug($this->conf);
		$this->siteUrl=$conf["siteUrl"];
		$str = trim($this->cObj->getCurrentVal());
		$this->cObj->data["header_layout"] = $this->cObj->parameters["type"];
//		debug($this->cObj->parameters["type"]);
		$this->cObj->data["header_position"] = $this->cObj->parameters["align"];
		$this->cObj->data["header"]=$str;
//		debug($this->conf);
		return $this->getHeader();
	}
	function typocode($content,$conf)	{	
			// Nothing is really done here...
		$this->conf = $conf;
		$this->siteUrl=$conf["siteUrl"];
		return $this->cObj->getCurrentVal();
	}






	function userProcess($mConfKey,$passVar)	{
		if ($this->conf[$mConfKey])	{
			$funcConf = $this->conf[$mConfKey."."];
			$funcConf["parentObj"]=&$this;
			$passVar = $GLOBALS["TSFE"]->cObj->callUserFunction($this->conf[$mConfKey], $funcConf, $passVar);
		}
		return $passVar;
	}

}




if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["media/scripts/plaintextLib.inc"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["media/scripts/plaintextLib.inc"]);
}


?>