<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


class fileList extends t3lib_recordList {
	var $iLimit = 40;			// default Max items shown 
	var $AB=0;
	var $thumbs = 0;						// Boolean. Thumbnails on records containing files (pictures)
	var $widthGif = '<img src="clear.gif" width=1 height=1 hspace=165>';
	var $fixedL = 30;						// Max length of strings
	var $script = "file_list.php";
	var $clickMenus=1;			// If true click menus are generated on files and folders

	var $sort = "";		// the field to sort by...
	var $sortRev = 1;	// Reverse sorting flag
	var $firstElementNumber=0;		// 
	var $clipBoard = 0;
	
		// internal
	var $JScode = "";	
	var $HTMLcode = "";
	var $totalbytes=0;
	var $dirs = Array();
	var $files = Array();
	var $path = "";
	var $eCounter=0;		// Counting the elements no matter what...
	var $totalItems="";

	var $CBnames=array();
	
	function start($path,$pointer,$sort,$sortRev,$clipBoard=0)	{
		$this->counter=0;
		$this->totalbytes=0;
		$this->JScode="";
		$this->HTMLcode="";
		$this->path = $path;
		$this->sort=$sort;
		$this->sortRev=$sortRev;
		$this->firstElementNumber=$pointer;
		$this->clipBoard = $clipBoard;

		if (!$GLOBALS["TYPO3_CONF_VARS"]["GFX"]["thumbnails"])	{
			$this->thumbScript='gfx/notfound_thumb.gif';
		}
	}
	function generateList()	{
		$this->dirs = $this->readDirectory($this->path,"dir");
		$this->files = $this->readDirectory($this->path,"file");
		$this->totalItems=count($this->dirs["sorting"])+count($this->files["sorting"]);
		$this->HTMLcode.=$this->getTable($this->files, $this->dirs, "fileext,tstamp,size,rw");
	}
	function writeTop($path)	{
			// Makes the code for the foldericon in the top
		$path = $GLOBALS["SOBE"]->basicFF->is_directory($path);	// Cleaning name...
		if ($path)	{
			$out="";
			$this->counter++;
			$theFile = $GLOBALS["SOBE"]->basicFF->getTotalFileInfo($path);
			$root = $GLOBALS["SOBE"]->basicFF->checkPathAgainstMounts($theFile["path"]);
			$titleCol="path";
			$this->fieldArray = Array($titleCol,"up");
	
			list($title,$icon,$path) =  $this->dirData($theFile);
	
				// JavaScript for clipboard
			$this->JScode.= "
			top.clipBrd.aI(thePad, '', '".t3lib_div::shortMD5($path)."', 'file', '".$title."', '".$path."', '', 'folder.gif');";
	
				// Start compiling the HTML
			$out="<table border=0 cellpadding=0 cellspacing=0>";
	
			$theData = Array();
			$theData[$titleCol] = $this->widthGif;
	
			$title = $GLOBALS["SOBE"]->basicFF->blindPath($path);
			$theData["up"]='<A href="'.$this->listURL().'"><img src="'.$this->backPath.'gfx/refresh_n.gif" width=14 hspace=2 height=14 vspace=1  border=0 title="'.$GLOBALS["LANG"]->php3Lang[labels][reload].'" align="top"></a>';
			if ($root)	{
					// The icon with link	
				$theIcon = '<img src="'.$this->backPath.$icon.'" width=18 height=16 border=0 title="'.$theFile["file"].'" align=top>';
				if ($this->clickMenus && !$this->AB)	{
					$theIcon = '<A HREF="#" onClick="top.funcMgr.openCM('.$this->counter.', \'fileListMenu\'); return false;">'.$theIcon.'</A>';
				} else {
					$theIcon = $GLOBALS["SOBE"]->doc->wrapClickMenuOnIcon($theIcon,$path);
				}
				$theData[$titleCol].="<BR>".fw(t3lib_div::fixed_lgd_pre($title,$this->fixedL+20));
				$theData["up"].=$this->linkWrapDir('<img src="'.$this->backPath.'gfx/i/folder_up.gif" width=18 height=16 border=0 title="'.$GLOBALS["LANG"]->php3Lang[labels][upOneLevel].'" align="top">',$theFile["path"]);
			} else {	
					// root:0
				$theIcon='<img src="'.$this->backPath.'gfx/i/_icon_ftp.gif" width=18 height=16 border=0 align=top>';
				$theData[$titleCol].="<BR>".fw(t3lib_div::fixed_lgd_pre($title,$this->fixedL+20));
			}
	
			$out.=$this->addelement(1,'',$theData,'',$this->leftMargin,$theIcon);
	
			$out.="</table>";
			$this->HTMLcode.=$out;
		}
	}
	function linkClipboardHeaderIcon($string,$table,$cmd,$warning="")	{
		$onClickEvent = 'document.dblistForm.cmd.value=\''.$cmd.'\';document.dblistForm.submit();';
		if ($warning)	$onClickEvent = 'if (confirm(unescape(\''.rawurlencode($warning).'\'))){'.$onClickEvent.'}';
		return '<a href="#" onClick="'.$onClickEvent.'return false;">'.$string.'</a>';
	}
	function getTable($files,$dirs,$rowlist)	{
			// Adds the code of files/dirs
		$out="";
		$titleCol = "file";
			// Cleaning rowlist for duplicates and place the $titleCol as the first column always!
		$rowlist = t3lib_div::rmFromList($titleCol,$rowlist);
		$rowlist = t3lib_div::uniqueList($rowlist);
		$rowlist = $rowlist ? $titleCol.",".$rowlist : $titleCol;
		if ($this->clipBoard)	$rowlist.=",_CLIPBOARD_";
		$this->fieldArray = explode(",",$rowlist);
		
			// Start table:
		$out.='<table border=0 cellpadding=0 cellspacing=0>';

			// half line is drawn
		$theData = Array();
		$theData[$titleCol] = $this->widthGif;
		$out.=$this->addelement(0,'',$theData,'',$this->leftMargin);

			// Directories are added
		$iOut = "";
		$iOut.= $this->formatDirList($dirs,$titleCol);
		
		if (count($dirs["sorting"]))	{
				// half line is drawn
			$theData = Array();
			$theData[$titleCol] = "";
			$iOut.=$this->addelement(0,'',$theData);
		}

			// files are added
		$iOut.= $this->formatFileList($files,$titleCol);

		
			// header line is drawn
		$theData = Array();
		reset($this->fieldArray);
		while(list(,$v)=each($this->fieldArray))	{
			if ($v=="_CLIPBOARD_")	{
				$cells=array();
				$table="_FILE";
				$elFromTable = $this->clipObj->elFromTable($table);
				if (count($elFromTable))	{
					$cells[]='<a href="'.$this->clipObj->pasteUrl("_FILE",$this->path).'" onClick="return '.$this->clipObj->confirmMsg("_FILE",$this->path,"into",$elFromTable).'"><img src="gfx/clip_pasteafter.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->getLL("clip_paste")).'></a><img src=clear.gif width=2 height=1>';
				}
				if ($this->clipObj->current!="normal" && $iOut)	{
					$cells[]=$this->linkClipboardHeaderIcon('<img src="gfx/clip_copy.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->getLL("clip_selectMarked")).'>',$table,"setCB");
					$cells[]=$this->linkClipboardHeaderIcon('<img src="gfx/garbage.gif" width="11" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->getLL("clip_deleteMarked")).'>',$table,"delete",$GLOBALS["LANG"]->getLL("clip_deleteMarkedWarning"));
					$cells[]='<img src=clear.gif width=6 height=1>';
					$cells[]='<a href="#" onClick="checkOffCB(\''.implode(",",$this->CBnames).'\'); return false;"><img src="gfx/clip_select.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->getLL("clip_markRecords")).'></a>';
				}

				$theData[$v] = fw(implode("",$cells)."&nbsp;");
			} else {
				$theT = $this->linkWrapSort($GLOBALS["LANG"]->getLL("c_".$v), $this->path,$v);
				if ($v==$titleCol)	{
					$theData[$v] = fw('&nbsp;<b>'.$theT.'</b>&nbsp;<BR><img src="clear.gif" width=180 height=1>');
				} else {
					$theData[$v] = fw('&nbsp;<b>'.$theT.'</b>&nbsp;');
				}
			}
		}
		$out.=$this->addelement(1,'',$theData,' bgcolor="'.$this->headLineCol.'"','');
		$out.=$iOut;
		
			// half line is drawn
		$theData = Array();
		$theData[$titleCol] = fw($this->counter." Files, ".$GLOBALS["SOBE"]->basicFF->formatSize($this->totalbytes)."bytes");
		$out.=$this->addelement(1,'',$theData);
		
			// finish
		$out.="</table>";	
		return $out;
	}
	function formatDirList($items)	{
			// This returns tablerows for the directories in the array $items. 
		$out="";
			// Files:
		if (count($items["sorting"]))	{
			reset($items["sorting"]);
			while (list($key,) = each($items["sorting"]))	{
				list($flag,$code) = $this->fwd_rwd_nav();
				$out.=$code;
				if ($flag)	{
						// Initialization
					$theFile = $items["files"][$key];
					$this->counter++;
	
					list($title,$icon,$path) =  $this->dirData($theFile);
//					$icon=$this->backPath.$icon;
	
						// JavaScript for clipboard
					$this->JScode.= "
					top.clipBrd.aI(thePad, '', '".t3lib_div::shortMD5($path)."', 'file', '".$title."', '".$path."', '', 'folder.gif');";
	
						// The icon with link	
					$theIcon = '<img src="'.$this->backPath.$icon.'" width=18 height=16 border=0 title="'.$theFile["file"].'">';
					if ($this->clickMenus && !$this->AB)	{
						$theIcon = '<A HREF="#" onClick="top.funcMgr.openCM('.$this->counter.', \'fileListMenu\');return false;">'.$theIcon.'</A>';
					} else {
						$theIcon = $GLOBALS["SOBE"]->doc->wrapClickMenuOnIcon($theIcon,$path);
					}
	
						// 	Preparing and getting the data-array
					$theData = Array();
					reset($this->fieldArray);
					while(list(,$field)=each($this->fieldArray))	{
						switch($field)	{
							case "size":
	//							$theData[$field]=$GLOBALS["SOBE"]->basicFF->formatSize($theFile[$field]);
							break;
							case "rw":
								$theData[$field]= (($theFile["readable"])?'':'<FONT color=red><b>R</b></font>').(($theFile["writeable"])?'':'<FONT color=red><b>W</b></font>');
							break;
							case "fileext":	
	//							$theData[$field]=strtoupper($theFile["fileext"]);
							break;
							case "tstamp":
								$theData[$field]=Date($GLOBALS["TYPO3_CONF_VARS"]["SYS"]["ddmmyy"], $theFile["tstamp"]);
							break;
							case "file":
								$theData[$field]= $this->linkWrapDir(t3lib_div::fixed_lgd($title,$this->fixedL),$path);
							break;
							case "_CLIPBOARD_":
								$theData[$field]=$this->makeClip($theFile);
							break;
							default:
								$theData[$field]=t3lib_div::fixed_lgd($theFile[$field],$this->fixedL);
							break;
						}
						if ($field!="_CLIPBOARD_")	$theData[$field]=fw('&nbsp;'.$theData[$field].'&nbsp;');
					}
					$out.=$this->addelement(1,$theIcon,$theData);
				}
				$this->eCounter++;
			}
		}
		return $out;
	}
	function linkWrapDir($code,$path)	{
			// wraps the directory-titles
		return '<A HREF="'.$this->script.'?id='.rawurlencode($path).'&AB='.$this->AB.'">'.$code.'</a>';
	}
	function listURL()	{
		return $this->script.'?id='.rawurlencode($this->path).'&imagemode='.$this->thumbs.($this->AB?"&AB=1":"");
	}
	function dirData($theFile)	{
			// Returns some data specific for the directories...
		$path = $theFile["path"].$theFile["file"]."/";
		$webpath=t3lib_BEfunc::getPathType_web_nonweb($path);

		$title=$theFile["file"];
		$icon = 'gfx/i/_icon_'.$webpath.'folders.gif';
		if ($title=="_temp_")	{
			$icon = 'gfx/i/sysf.gif';
			$title="<b>TEMP</b>";
		}
		if ($title=="_recycler_")	{
			$icon = 'gfx/i/recycler.gif';
			$title="<b>RECYCLER</b>";
		}
		$icon = $theFile["writable"] ? "gfx/i/_icon_".$webpath."folders_ro.gif" : $icon;
//		$icon=$this->backPath.$icon;
		return Array($title,$icon,$path);
	}
	function formatFileList($items)	{
			// This returns tablerows for the files in the array $items. $titleCol is the name of the titleColumn ("file")
		$out="";
			// Files:
		if (count($items["sorting"]))	{
			reset($items["sorting"]);
			while (list($key,) = each($items["sorting"]))	{
				list($flag,$code) = $this->fwd_rwd_nav();
				$out.=$code;
				if ($flag)	{
						// Initialization
					$theFile = $items["files"][$key];
					$this->counter++;
	
					$this->totalbytes+=$theFile["size"];
					$ext = $items["files"][$key][fileext];
					$icon = t3lib_BEfunc::getFileIcon($ext);

						// JavaScript for clipboard
					$this->JScode.= "
					top.clipBrd.aI(thePad, '', '".t3lib_div::shortMD5($theFile["path"].$theFile["file"])."', 'file', '".$theFile["file"]."', '".$theFile["path"].$theFile["file"]."', '".$theFile["fileext"]."', '".$icon."');";
	
						// The icon with link	
					$theIcon = '<img src="'.$this->backPath.'gfx/fileicons/'.$icon.'" width=18 height=16 border=0 title="'.$theFile["file"].'">';
					if ($this->clickMenus && !$this->AB)	{
						$theIcon = '<A HREF="#" onClick="top.funcMgr.openCM('.$this->counter.', \'fileListMenu\');return false;">'.$theIcon.'</A>';
					} else {
						$theIcon = $GLOBALS["SOBE"]->doc->wrapClickMenuOnIcon($theIcon,$theFile["path"].$theFile["file"]);
					}
	
						// 	Preparing and getting the data-array
					$theData = Array();
					reset($this->fieldArray);
					while(list(,$field)=each($this->fieldArray))	{
						switch($field)	{
							case "size":
								$theData[$field]=$GLOBALS["SOBE"]->basicFF->formatSize($theFile[$field]);
							break;
							case "rw":
								$theData[$field]= (($theFile["readable"])?'':'<FONT color=red><b>R</b></font>').(($theFile["writeable"])?'':'<FONT color=red><b>W</b></font>');
							break;
							case "fileext":
								$theData[$field]=strtoupper($theFile[$field]);
							break;
							case "tstamp":
								$theData[$field]=Date($GLOBALS["TYPO3_CONF_VARS"]["SYS"]["ddmmyy"], $theFile[$field]);
							break;
							case "_CLIPBOARD_":
								$theData[$field]=$this->makeClip($theFile);
							break;
							default:
								$theData[$field]=t3lib_div::fixed_lgd($theFile[$field],$this->fixedL);
							break;
						}
						if ($field!="_CLIPBOARD_")	$theData[$field]=fw('&nbsp;'.$theData[$field].'&nbsp;');
					}
					$out.=$this->addelement(1,$theIcon,$theData);
					
						// Thumbsnails?
					if ($this->thumbs && $this->isImage($theFile["fileext"]))	{
						$thumbData=Array();
						$theFile_R = rawurlencode($theFile["path"].$theFile["file"]);
						$titleCol=$this->fieldArray[0];
						$thumbData[$titleCol]='<img src="'.$this->backPath.$this->thumbScript.'?&dummy='.$GLOBALS["EXEC_TIME"].'&file='.$theFile_R.'" hspace=2 border=0 title="'.trim($theFile["file"]).'">';
						if (!$this->AB)	{
							$thumbData[$titleCol]='<A HREF="#" onClick="top.launchView(unescape(\''.$theFile_R.'\'),\'\');">'.$thumbData[$titleCol].'</a>';
						}
						$out.=$this->addelement(4,"",$thumbData);
					}
				}
				$this->eCounter++;
			}
		}
		return $out;
	}
	function isImage($ext)	{
			// Returns true if ext is an image-extension according to $GLOBALS["TYPO3_CONF_VARS"]["GFX"]["imagefile_ext"]
		return t3lib_div::inList($GLOBALS["TYPO3_CONF_VARS"]["GFX"]["imagefile_ext"],strtolower($ext));
	}
	function linkWrapSort($code,$path,$col)	{
			// wraps the directory-titles ($code) in a link to file_list.php (id=$path) and sorting commands...
		if ($this->sort==$col && !$this->sortRev)	{		// reverse sorting
			$params="&SET[sort]=".$col."&SET[reverse]=1";
		} else {
			$params="&SET[sort]=".$col."&SET[reverse]=0";
		}
		return '<A HREF="'.$this->script.'?id='.rawurlencode($path).$params.'&AB='.$this->AB.'">'.$code.'</a>';
	}
	function readDirectory($path,$type,$extList="")	{
		// Returns an array with file/dir items + a array with the sorted items
		// $type is the technical type; file,dir,link. empty is all kinds of stuff.
		// $extList: List of fileextensions to select. If empty, all are selected.

		$items = Array("files"=>array(), "sorting"=>array());
		$path = $GLOBALS["SOBE"]->basicFF->is_directory($path);	// Cleaning name...

		if($path && $GLOBALS["SOBE"]->basicFF->checkPathAgainstMounts($path."/"))	{
			$d = @dir($path);
			$tempArray=Array();
			if (is_object($d))	{
				while($entry=$d->read()) {
					if ($entry!="." && $entry!="..")	{
						$wholePath = $path."/".$entry;		// Because of odd PHP-error where  <BR>-tag is sometimes placed after a filename!!
						if (@file_exists($wholePath) && (!$type || filetype($wholePath)==$type))	{
							if ($extList)	{
								$fI = t3lib_div::split_fileref($entry);
								if (t3lib_div::inList($extList,$fI["fileext"]))	{
									$tempArray[] = $wholePath;
								}
							} else {
								$tempArray[] = $wholePath;
							}
						}
					}
				}
				$d->close();
			}
				// Get fileinfo
			reset($tempArray);
			while (list(,$val)=each($tempArray))	{
				$temp = $GLOBALS["SOBE"]->basicFF->getTotalFileInfo($val);
				$items["files"][] = $temp;
				if ($this->sort)	{
					$items["sorting"][] = strtoupper($temp[$this->sort]);
				} else {
					$items["sorting"][] = "";
				}
			}
				// Sort if required
			if ($this->sort)	{
				if (!$this->sortRev)	{
					asort($items["sorting"]);
				} else {
					arsort($items["sorting"]);
				}
			}
		}
		return $items;
	}
	function makeClip($theData)	{
//		debug($theData);
		
		$cells=array();
		$fullIdent = $theData["path"].$theData["file"];
		$md5=t3lib_div::shortmd5($fullIdent);

		if ($this->clipObj->current=="normal")	{
			$isSel = $this->clipObj->isSelected("_FILE",$md5);
			$cells[]='<a href="'.$this->clipObj->selUrlFile($fullIdent,1,($isSel=="copy")).'"><img src="gfx/clip_copy'.($isSel=="copy"?"_h":"").'.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->mainLang["cm"]["copy"]).'></a>';
			$cells[]='<a href="'.$this->clipObj->selUrlFile($fullIdent,0,($isSel=="cut")).'"><img src="gfx/clip_cut'.($isSel=="cut"?"_h":"").'.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->mainLang["cm"]["cut"]).'></a>';
		} else {
			$n="_FILE|".$md5;
			$this->CBnames[]=$n;

			$checked = ($this->clipObj->isSelected("_FILE",$md5)?" checked":"");
			$cells[]='<input type="hidden" name="CBH['.$n.']" value="0"><input type="checkbox" name="CBC['.$n.']" value="'.htmlspecialchars($fullIdent).'" style="width:12;height:12;margin:0 0 0 0;"'.$checked.'>';	// NN 6.1
		}

		$elFromTable = $this->clipObj->elFromTable("_FILE");
		if (@is_dir($fullIdent) && count($elFromTable))	{
			$cells[]='<a href="'.$this->clipObj->pasteUrl("_FILE",$fullIdent).'" onClick="return '.$this->clipObj->confirmMsg("_FILE",$fullIdent,"into",$elFromTable).'"><img src="gfx/clip_pasteinto.gif" width="12" height="12" border="0"'.t3lib_BEfunc::titleAttrib($GLOBALS["LANG"]->getLL("clip_pasteInto")).'></a>';
		}

		if ($GLOBALS["CLIENT"]["BROWSER"]=="net" && $GLOBALS["CLIENT"]["VERSION"]<5)	{
			$w100 = '';
			$w40 = '';
		} else {
			$w100 = ' width="100%"';
			$w40 = ' width="40%"';
		}
		return '<table border=0 cellpadding=1 cellspacing=0 bgColor="'.$GLOBALS["SOBE"]->doc->bgColor5.'"'.$w100.'><tr><td'.$w40.'></td><td align=center>'.implode("</td><td>",$cells).'</td><td'.$w40.'></td></tr></table>';
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/class.file_list.inc"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/class.file_list.inc"]);
}

?>