<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

require_once(PATH_t3lib."class.t3lib_page.php");
require_once(PATH_t3lib."class.t3lib_tcemain.php");

require_once(PATH_t3lib."class.t3lib_extobjbase.php");

class tx_wizardsortpages_webfunc_2 extends t3lib_extobjbase {
	var $localLangFile = "locallang.php";

	function modMenu()	{
		global $LANG;
		
		$modMenuAdd = array(
			"sort_blablabla" => array(
				"2" => "TO",
				"1" => "et"
			)
		);
		return $modMenuAdd;
	}
	function main()	{
		global $SOBE,$LANG;

		$theCode="";

			// check if user has modify permissions to 
		$sys_pages = t3lib_div::makeInstance("t3lib_pageSelect");
		$sortByField = t3lib_div::GPvar("sortByField");
		if ($sortByField)	{
			$menuItems=array();
			if (t3lib_div::inList("title,subtitle,crdate,tstamp",$sortByField))	{
				$menuItems = $sys_pages->getMenu($this->pObj->id,"uid,pid,title",$sortByField);
			} elseif ($sortByField=="REV") {
				$menuItems = $sys_pages->getMenu($this->pObj->id,"uid,pid,title");
				$menuItems = array_reverse($menuItems);
			}
			if (count($menuItems))	{
				$tce = t3lib_div::makeInstance("t3lib_TCEmain");
				$menuItems = array_reverse($menuItems);
				$cmd=array();
				reset($menuItems);
				while(list(,$r)=each($menuItems))	{
					$cmd["pages"][$r["uid"]]["move"]=$this->pObj->id;
				}
				$tce->start(array(),$cmd);
				$tce->process_cmdmap();
				t3lib_BEfunc::getSetUpdateSignal("updatePageTree");
			}
		}

			//
		$menuItems = $sys_pages->getMenu($this->pObj->id);
		reset($menuItems);
		$lines=array();
			$lines[]= '<tr>
				<td bgColor="'.$this->pObj->doc->bgColor5.'"><B>'.fw($this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_title"),"title")).'</B></td>
				'.(t3lib_extMgm::isLoaded("cms")?'<td bgColor="'.$this->pObj->doc->bgColor5.'"><B>'.fw($this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_subtitle"),"subtitle")).'</B></td>':'').'
				<td bgColor="'.$this->pObj->doc->bgColor5.'"><B>'.fw($this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_tChange"),"tstamp")).'</B></td>
				<td bgColor="'.$this->pObj->doc->bgColor5.'"><B>'.fw($this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_tCreate"),"crdate")).'</B></td>
				</tr>';
		while(list(,$rec)=each($menuItems))	{
			$m_perms_clause = $GLOBALS["BE_USER"]->getPagePermsClause(2);	// edit permissions for that page!
			$pRec = t3lib_BEfunc::getRecord ("pages",$rec["uid"],"uid"," AND ".$m_perms_clause);
			$lines[]= '<tr><td nowrap>'.t3lib_iconWorks::getIconImage("pages",$rec,$GLOBALS["BACK_PATH"],'align=top '.t3lib_BEfunc::titleAttribForPages($rec)).
				(!is_array($pRec)?rfw('<B>'.$LANG->getLL("wiz_W").'</B> '):'').
				fw(htmlspecialchars(t3lib_div::fixed_lgd($rec["title"],$GLOBALS["BE_USER"]->uc["titleLen"]))."&nbsp;").'</td>
				'.(t3lib_extMgm::isLoaded("cms")?'<td nowrap>'.fw(htmlspecialchars(t3lib_div::fixed_lgd($rec["subtitle"],$GLOBALS["BE_USER"]->uc["titleLen"]))."&nbsp;").'</td>':'').'
				<td nowrap>'.fw(t3lib_Befunc::datetime($rec["tstamp"])."&nbsp;&nbsp;").'</td>
				<td nowrap>'.fw(t3lib_Befunc::datetime($rec["crdate"])."&nbsp;&nbsp;").'</td>
				</tr>';
		}
		
		$theCode.= '<B>'.$LANG->getLL("wiz_currentPageOrder").':</B><BR><BR>
		<table border=0 cellpadding=0 cellspacing=0>'.implode("",$lines).'</table><BR>';

		if (count($menuItems))	{
				// Menu:
			$lines=array();
			$lines[] = $this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_title"),"title");
			if (t3lib_extMgm::isLoaded("cms")) $lines[] = $this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_subtitle"),"subtitle");
			$lines[] = $this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_tChange"),"tstamp");
			$lines[] = $this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_tCreate"),"crdate");
			$lines[] = "";
			$lines[] = $this->wiz_linkOrder($LANG->getLL("wiz_changeOrder_REVERSE"),"REV");
			$theCode.= '<B>'.$LANG->getLL("wiz_changeOrder").':</B><BR><BR>'.implode("<BR>",$lines);
		}			

		$out=$this->pObj->doc->section($LANG->getLL("wiz_sort"),$theCode,0,1);
		return $out;
	}
	function wiz_linkOrder($title,$order)	{
		return '&nbsp; &nbsp;<a href="index.php?id='.$GLOBALS["SOBE"]->id.'&sortByField='.$order.'" onClick="return confirm(unescape(\''.rawurlencode($GLOBALS["LANG"]->getLL("wiz_changeOrder_msg1")).'\'))">'.$title.'</a>';
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/wizard_sortpages/class.tx_wizardsortpages_webfunc_2.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/wizard_sortpages/class.tx_wizardsortpages_webfunc_2.php"]);
}

?>