<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Parent class for "Extension Objects" in backend modules.
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */


class t3lib_extobjbase {
	var $thisPath = "";
	var $localLangFile = "locallang.php";
	var $pObj;	// parent SC object
	var $function_key="";
	var $extClassConf;
	
	function init(&$pObj,$conf)	{
		global $LANG;

		$this->pObj = &$pObj;
		
			// Path of this script:
		$this->thisPath = dirname($conf["path"]);
		if (!@is_dir($this->thisPath))	{
			die("Error: ".$this->thisPath." was not a directory as expected...");
		}
		
			// Local lang:
		$this->incLocalLang();
		
			// Setting MOD_MENU items as we need them for logging:
		$this->pObj->MOD_MENU = array_merge($this->pObj->MOD_MENU,$this->modMenu());		// Candidate for t3lib_div::array_merge() if integer-keys will some day make trouble...
	}
	function handleExternalFunctionValue()	{
			// Must clean first to make sure the correct key is set...
		$this->pObj->MOD_SETTINGS = t3lib_BEfunc::getModuleData($this->pObj->MOD_MENU, t3lib_div::GPvar("SET"), $this->pObj->MCONF["name"]);
		if ($this->function_key)	{
			$this->extClassConf = $this->pObj->getExternalItemConfig($this->pObj->MCONF["name"],$this->function_key,$this->pObj->MOD_SETTINGS[$this->function_key]);
			if (is_array($this->extClassConf) && $this->extClassConf["path"])	{
				$this->pObj->include_once[]=$this->extClassConf["path"];
			}
		}
	}
	function incLocalLang()	{
		if ($this->localLangFile && @is_file($this->thisPath."/".$this->localLangFile))	{
			include($this->thisPath."/".$this->localLangFile);
			$GLOBALS["LOCAL_LANG"]=t3lib_div::array_merge_recursive_overrule($GLOBALS["LOCAL_LANG"],$LOCAL_LANG);
		}
	}
	function checkExtObj()	{
		if (is_array($this->extClassConf) && $this->extClassConf["name"])	{
			$this->extObj = t3lib_div::makeInstance($this->extClassConf["name"]);
			$this->extObj->init($this->pObj,$this->extClassConf);

				// Re-write:
			$this->pObj->MOD_SETTINGS = t3lib_BEfunc::getModuleData($this->pObj->MOD_MENU, t3lib_div::GPvar("SET"), $this->pObj->MCONF["name"]);
		}
	}
	function extObjContent()	{
		if (is_object($this->extObj))	return $this->extObj->main();
	}
	function modMenu()	{
		return array();
	}
}

/*
 // Does not make sense, because this class is always extended by the extension object classes..
if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["t3lib/class.t3lib_scbase.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["t3lib/class.t3lib_scbase.php"]);
}
*/

?>